class TagsImporter
  attr_accessor :items

  def import
    tags = {}
    @items.each do |learning_object|
      categories = parse_tags learning_object.get_metadata_values_of 'dc.subject.category'
      keywords = learning_object.get_metadata_values_of 'dc.subject.keyword'
      (categories + keywords).each do |tag_name|
        unless tag_exists?(tag_name, tags)
          tags[tag_name] = Tag.new(name: tag_name)
        end
      end
    end

    Tag.import tags.values
  end

  private

  def parse_tags(values)
    tags = []
    values.compact.each { |value| tags << value.split('::') }
    tags.flatten.uniq.map(&:strip)
  end

  def tag_exists? (tag_name, tags)
    !Tag.find_by_name(tag_name).nil? || !tags[tag_name].nil?
  end

end
